Knowledge Sources - Create
Creates a new knowledge source.
POST {endpoint}/knowledgesources?api-version=2026-11-01-preview
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
endpoint
|
path | True |
string (uri) |
The endpoint URL of the search service. |
|
api-version
|
query | True |
string minLength: 1 |
The API version to use for this operation. |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| x-ms-client-request-id |
string (uuid) |
An opaque, globally-unique, client-generated string identifier for the request. |
|
| Accept |
The Accept header. |
Request Body
The request body can be one of the following:
| Name | Description |
|---|---|
|
Azure |
Configuration for Azure Blob Storage knowledge source. |
|
Fabric |
Configuration for Fabric Data Agent knowledge source. |
|
Fabric |
Configuration for Fabric Ontology knowledge source. |
|
File |
Configuration for File knowledge source that supports direct file upload and indexing. |
|
Indexed |
Configuration for OneLake knowledge source. |
|
Indexed |
Configuration for SharePoint knowledge source. |
|
Indexed |
Configuration for indexed SQL knowledge source. |
|
Mcp |
Configuration for a knowledge source backed by an MCP (Model Context Protocol) server. |
|
Remote |
Configuration for remote SharePoint knowledge source. |
|
Search |
Knowledge Source targeting a search index. |
|
Web |
Knowledge Source targeting web results. |
|
Work |
Configuration for WorkIQ knowledge source. |
AzureBlobKnowledgeSource
Configuration for Azure Blob Storage knowledge source.
| Name | Required | Type | Description |
|---|---|---|---|
| azureBlobParameters | True |
The type of the knowledge source. |
|
| kind | True |
string:
azure |
The type of the knowledge source. |
| name | True |
string |
The name of the knowledge source. |
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
FabricDataAgentKnowledgeSource
Configuration for Fabric Data Agent knowledge source.
| Name | Required | Type | Description |
|---|---|---|---|
| fabricDataAgentParameters | True |
The parameters for the Fabric Data Agent knowledge source. |
|
| kind | True |
string:
fabric |
The type of the knowledge source. |
| name | True |
string |
The name of the knowledge source. |
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
FabricOntologyKnowledgeSource
Configuration for Fabric Ontology knowledge source.
| Name | Required | Type | Description |
|---|---|---|---|
| fabricOntologyParameters | True |
The parameters for the Fabric Ontology knowledge source. |
|
| kind | True |
string:
fabric |
The type of the knowledge source. |
| name | True |
string |
The name of the knowledge source. |
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
FileKnowledgeSource
Configuration for File knowledge source that supports direct file upload and indexing.
| Name | Required | Type | Description |
|---|---|---|---|
| fileParameters | True |
The parameters for the File knowledge source. |
|
| kind | True |
string:
file |
The type of the knowledge source. |
| name | True |
string |
The name of the knowledge source. |
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| corsOptions |
Options to control Cross-Origin Resource Sharing (CORS) for the File knowledge source's file endpoints (upload, list, update, delete). |
||
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
IndexedOneLakeKnowledgeSource
Configuration for OneLake knowledge source.
| Name | Required | Type | Description |
|---|---|---|---|
| indexedOneLakeParameters | True |
The parameters for the knowledge source. |
|
| kind | True |
string:
indexed |
The type of the knowledge source. |
| name | True |
string |
The name of the knowledge source. |
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
IndexedSharePointKnowledgeSource
Configuration for SharePoint knowledge source.
| Name | Required | Type | Description |
|---|---|---|---|
| indexedSharePointParameters | True |
The parameters for the knowledge source. |
|
| kind | True |
string:
indexed |
The type of the knowledge source. |
| name | True |
string |
The name of the knowledge source. |
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
IndexedSqlKnowledgeSource
Configuration for indexed SQL knowledge source.
| Name | Required | Type | Description |
|---|---|---|---|
| indexedSqlParameters | True |
The parameters for the SQL knowledge source. |
|
| kind | True |
string:
indexed |
The type of the knowledge source. |
| name | True |
string |
The name of the knowledge source. |
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
McpServerKnowledgeSource
Configuration for a knowledge source backed by an MCP (Model Context Protocol) server.
| Name | Required | Type | Description |
|---|---|---|---|
| kind | True |
string:
mcp |
The type of the knowledge source. |
| mcpServerParameters | True |
The parameters for the MCP server knowledge source. |
|
| name | True |
string |
The name of the knowledge source. |
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
RemoteSharePointKnowledgeSource
Configuration for remote SharePoint knowledge source.
| Name | Required | Type | Description |
|---|---|---|---|
| kind | True |
string:
remote |
The type of the knowledge source. |
| name | True |
string |
The name of the knowledge source. |
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| remoteSharePointParameters |
The parameters for the remote SharePoint knowledge source. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
SearchIndexKnowledgeSource
Knowledge Source targeting a search index.
| Name | Required | Type | Description |
|---|---|---|---|
| kind | True |
string:
search |
The type of the knowledge source. |
| name | True |
string |
The name of the knowledge source. |
| searchIndexParameters | True |
The parameters for the knowledge source. |
|
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
WebKnowledgeSource
Knowledge Source targeting web results.
| Name | Required | Type | Description |
|---|---|---|---|
| kind | True |
string:
web |
The type of the knowledge source. |
| name | True |
string |
The name of the knowledge source. |
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
||
| webParameters |
The parameters for the web knowledge source. |
WorkIQKnowledgeSource
Configuration for WorkIQ knowledge source.
| Name | Required | Type | Description |
|---|---|---|---|
| kind | True |
string:
workIQ |
The type of the knowledge source. |
| name | True |
string |
The name of the knowledge source. |
| workIQParameters | True |
The parameters for the WorkIQ knowledge source, including the customer-owned Entra app configuration used for on-behalf-of authentication. |
|
| @odata.etag |
string |
The ETag of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
|
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
||
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
Responses
| Name | Type | Description |
|---|---|---|
| 201 Created |
KnowledgeSource:
|
The request has succeeded and a new resource has been created as a result. |
| Other Status Codes |
An unexpected error response. |
Security
api-key
Type:
apiKey
In:
header
OAuth2Auth
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/v2.0/authorize
Scopes
| Name | Description |
|---|---|
| https://search.azure.com/.default |
Examples
SearchServiceCreateKnowledgeSource
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "ks-preview-test",
"description": "Description of the knowledge source.",
"kind": "searchIndex",
"resultsProcessing": "none",
"@odata.etag": "0x1234568AE7E58A1",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"searchIndexParameters": {
"searchIndexName": "preview-test",
"sourceDataFields": [
{
"name": "description"
},
{
"name": "category"
}
],
"searchFields": [
{
"name": "*"
}
],
"semanticConfigurationName": "testconfig",
"baseFilter": "category eq 'news'",
"queryHints": {
"filters": [
{
"field": "model",
"fieldValues": [
"Model-X100",
"Model-X200",
"Model-Pro"
],
"filterInstructions": "Product model name."
}
],
"boosts": [
{
"kind": "fieldValue",
"boostInstructions": "Document language; pick from the user's locale.",
"field": "language",
"fieldValues": [
"en",
"ja",
"fr",
"de"
],
"boost": 2
}
]
}
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-preview-test",
"kind": "searchIndex",
"description": "Description of the knowledge source.",
"resultsProcessing": "none",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"isServiceLevelKey": false,
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"searchIndexParameters": {
"searchIndexName": "preview-test",
"semanticConfigurationName": "testconfig",
"baseFilter": "category eq 'news'",
"sourceDataFields": [
{
"name": "description"
},
{
"name": "category"
}
],
"searchFields": [
{
"name": "*"
}
],
"queryHints": {
"filters": [
{
"field": "model",
"fieldValues": [
"Model-X100",
"Model-X200",
"Model-Pro"
],
"filterInstructions": "Product model name."
}
],
"boosts": [
{
"kind": "fieldValue",
"field": "language",
"fieldValues": [
"en",
"ja",
"fr",
"de"
],
"boost": 2,
"boostInstructions": "Document language; pick from the user's locale."
}
]
}
}
}
SearchServiceCreateKnowledgeSourceAzureBlob
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "ks-preview-test",
"description": "Description of the knowledge source.",
"kind": "azureBlob",
"@odata.etag": "0x1234568AE7E58A1",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"azureBlobParameters": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "test-container",
"folderPath": "test-path",
"isADLSGen2": false,
"ingestionParameters": {
"identity": {
"@odata.type": "#Microsoft.Azure.Search.DataUserAssignedIdentity",
"userAssignedIdentity": "/my/userassigned/id"
},
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"disableImageVerbalization": false,
"ingestionSchedule": {
"interval": "P1D",
"startTime": "2025-01-07T19:30:00Z"
},
"ingestionPermissionOptions": [
"rbacScope"
],
"contentExtractionMode": "standard",
"aiServices": {
"uri": "https://my-ai-service.azure.com/",
"apiKey": "api-key"
},
"assetStore": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "image-assets"
},
"freshnessPolicy": {
"boostingDuration": "P90D"
},
"networkAccessMode": "private"
}
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-preview-test",
"kind": "azureBlob",
"description": "Description of the knowledge source.",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"isServiceLevelKey": false,
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"azureBlobParameters": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "test-container",
"folderPath": "test-path",
"isADLSGen2": false,
"ingestionParameters": {
"disableImageVerbalization": false,
"ingestionPermissionOptions": [
"rbacScope"
],
"contentExtractionMode": "standard",
"networkAccessMode": "private",
"identity": {
"@odata.type": "#Microsoft.Azure.Search.DataUserAssignedIdentity",
"userAssignedIdentity": "/my/userassigned/id"
},
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"ingestionSchedule": {
"interval": "P1D",
"startTime": "2024-06-06T00:01:50.265Z"
},
"assetStore": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "image-assets"
},
"aiServices": {
"uri": "https://my-ai-service.azure.com/",
"apiKey": "api-key"
},
"freshnessPolicy": {
"boostingDuration": "P90D"
}
},
"createdResources": {
"datasource": "ks-preview-test-datasource",
"indexer": "ks-preview-test-indexer",
"skillset": "ks-preview-test-skillset",
"index": "ks-preview-test-index"
}
}
}
SearchServiceCreateKnowledgeSourceAzureBlobGraphCache
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "ks-graph-cache",
"kind": "azureBlob",
"azureBlobParameters": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "test-container",
"isADLSGen2": false,
"ingestionParameters": {
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"disableImageVerbalization": true,
"ingestionSchedule": {
"interval": "P1D",
"startTime": "2025-01-07T19:30:00Z"
},
"contentExtractionMode": "minimal",
"cache": {
"storageConnectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"enableReprocessing": true
}
},
"graphExtraction": {
"graphName": "products"
}
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-graph-cache",
"kind": "azureBlob",
"azureBlobParameters": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "test-container",
"isADLSGen2": false,
"ingestionParameters": {
"disableImageVerbalization": true,
"contentExtractionMode": "minimal",
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"ingestionSchedule": {
"interval": "P1D",
"startTime": "2024-06-06T00:01:50.265Z"
},
"cache": {
"enableReprocessing": true
}
},
"graphExtraction": {
"graphName": "products"
},
"createdResources": {
"datasource": "ks-graph-cache-datasource",
"indexer": "ks-graph-cache-indexer",
"skillset": "ks-graph-cache-skillset",
"index": "ks-graph-cache-index"
}
}
}
SearchServiceCreateKnowledgeSourceCompatibleChat
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "image-documents",
"kind": "azureBlob",
"azureBlobParameters": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "documents",
"ingestionParameters": {
"chatCompletionModel": {
"kind": "openAICompatible",
"openAICompatibleParameters": {
"uri": "https://model-gateway.contoso.com/teams/catalog/chat/completions?route=primary&api-version=2026-01-01",
"modelName": "gpt-4.1-mini",
"headers": {
"api-key": "test-key"
}
}
},
"disableImageVerbalization": false,
"contentExtractionMode": "minimal"
}
}
}
Sample response
{
"name": "image-documents",
"kind": "azureBlob",
"azureBlobParameters": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "documents",
"ingestionParameters": {
"chatCompletionModel": {
"kind": "openAICompatible",
"openAICompatibleParameters": {
"uri": "https://model-gateway.contoso.com/teams/catalog/chat/completions?route=primary&api-version=2026-01-01",
"modelName": "gpt-4.1-mini"
}
},
"disableImageVerbalization": false,
"contentExtractionMode": "minimal"
}
}
}
SearchServiceCreateKnowledgeSourceFile
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "ks-preview-test",
"description": "Description of the File knowledge source.",
"kind": "file",
"fileParameters": {
"ingestionParameters": {
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"contentExtractionMode": "standard",
"aiServices": {
"uri": "https://my-ai-service.azure.com/",
"apiKey": "api-key"
}
}
},
"corsOptions": {
"allowedOrigins": [
"https://myapp.example.com"
],
"maxAgeInSeconds": 300
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-preview-test",
"kind": "file",
"description": "Description of the File knowledge source.",
"fileParameters": {
"ingestionParameters": {
"contentExtractionMode": "standard",
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"aiServices": {
"uri": "https://my-ai-service.azure.com/",
"apiKey": "api-key"
}
},
"createdResources": {
"index": "ks-preview-test-index"
}
},
"corsOptions": {
"allowedOrigins": [
"https://myapp.example.com"
],
"maxAgeInSeconds": 300
}
}
SearchServiceCreateKnowledgeSourceIndexedOneLake
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "ks-preview-test",
"description": "Description of the OneLake knowledge source.",
"kind": "indexedOneLake",
"@odata.etag": "0x1234568AE7E58A1",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"indexedOneLakeParameters": {
"fabricWorkspaceId": "ResourceId=fakeWorkspaceId",
"lakehouseId": "fakeLakehouseId",
"targetPath": "testfolder",
"ingestionParameters": {
"identity": {
"@odata.type": "#Microsoft.Azure.Search.DataUserAssignedIdentity",
"userAssignedIdentity": "/my/userassigned/id"
},
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"disableImageVerbalization": false,
"ingestionSchedule": {
"interval": "P1D",
"startTime": "2025-01-07T19:30:00Z"
},
"contentExtractionMode": "standard",
"aiServices": {
"uri": "https://my-ai-service.azure.com/",
"apiKey": "api-key"
},
"assetStore": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "image-assets"
}
}
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-preview-test",
"kind": "indexedOneLake",
"description": "Description of the OneLake knowledge source.",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"isServiceLevelKey": false,
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"indexedOneLakeParameters": {
"fabricWorkspaceId": "ResourceId=fakeWorkspaceId",
"lakehouseId": "fakeLakehouseId",
"targetPath": "testfolder",
"ingestionParameters": {
"disableImageVerbalization": false,
"contentExtractionMode": "standard",
"identity": {
"@odata.type": "#Microsoft.Azure.Search.DataUserAssignedIdentity",
"userAssignedIdentity": "/my/userassigned/id"
},
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"ingestionSchedule": {
"interval": "P1D",
"startTime": "2024-06-06T00:01:50.265Z"
},
"assetStore": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "image-assets"
},
"aiServices": {
"uri": "https://my-ai-service.azure.com/",
"apiKey": "api-key"
}
}
}
}
SearchServiceCreateKnowledgeSourceIndexedSharePoint
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "ks-preview-test",
"description": "Description of the SharePoint knowledge source.",
"kind": "indexedSharePoint",
"@odata.etag": "0x1234568AE7E58A1",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"indexedSharePointParameters": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "defaultSiteLibrary",
"query": "*.docx OR *.pdf",
"ingestionParameters": {
"identity": {
"@odata.type": "#Microsoft.Azure.Search.DataUserAssignedIdentity",
"userAssignedIdentity": "/my/userassigned/id"
},
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"disableImageVerbalization": false,
"ingestionSchedule": {
"interval": "P1D",
"startTime": "2025-01-07T19:30:00Z"
},
"ingestionPermissionOptions": [
"userIds",
"groupIds"
],
"contentExtractionMode": "standard",
"aiServices": {
"uri": "https://my-ai-service.azure.com/",
"apiKey": "api-key"
},
"assetStore": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "image-assets"
},
"freshnessPolicy": {
"boostingDuration": "P90D"
}
}
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-preview-test",
"kind": "indexedSharePoint",
"description": "Description of the SharePoint knowledge source.",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"isServiceLevelKey": false,
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"indexedSharePointParameters": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "defaultSiteLibrary",
"query": "*.docx OR *.pdf",
"ingestionParameters": {
"disableImageVerbalization": false,
"ingestionPermissionOptions": [
"userIds",
"groupIds"
],
"contentExtractionMode": "standard",
"identity": {
"@odata.type": "#Microsoft.Azure.Search.DataUserAssignedIdentity",
"userAssignedIdentity": "/my/userassigned/id"
},
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"ingestionSchedule": {
"interval": "P1D",
"startTime": "2024-06-06T00:01:50.265Z"
},
"assetStore": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"containerName": "image-assets"
},
"aiServices": {
"uri": "https://my-ai-service.azure.com/",
"apiKey": "api-key"
},
"freshnessPolicy": {
"boostingDuration": "P90D"
}
}
}
}
SearchServiceCreateKnowledgeSourceIndexedSql
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "ks-preview-test",
"description": "Description of the SQL knowledge source.",
"kind": "indexedSql",
"@odata.etag": "0x1234568AE7E58A1",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"indexedSqlParameters": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"tableOrView": "dbo.Products",
"contentColumns": [
{
"name": "title",
"sourceField": "Title",
"searchFieldType": "Edm.String"
},
{
"name": "description",
"sourceField": "Description",
"searchFieldType": "Edm.String"
},
{
"name": "price",
"sourceField": "Price",
"searchFieldType": "Edm.Double"
}
],
"embeddingColumns": [
{
"name": "descriptionEmbedding",
"sourceField": "Description"
}
],
"ingestionParameters": {
"identity": {
"@odata.type": "#Microsoft.Azure.Search.DataUserAssignedIdentity",
"userAssignedIdentity": "/my/userassigned/id"
},
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"ingestionSchedule": {
"interval": "P1D",
"startTime": "2025-01-07T19:30:00Z"
},
"contentExtractionMode": "minimal"
}
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-preview-test",
"kind": "indexedSql",
"description": "Description of the SQL knowledge source.",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"isServiceLevelKey": false,
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"indexedSqlParameters": {
"connectionString": "DefaultEndpointsProtocol=https;AccountName=myAccountName;AccountKey=myAccountKey;EndpointSuffix=core.windows.net ",
"tableOrView": "dbo.Products",
"contentColumns": [
{
"name": "title",
"sourceField": "Title",
"searchFieldType": "Edm.String"
},
{
"name": "description",
"sourceField": "Description",
"searchFieldType": "Edm.String"
},
{
"name": "price",
"sourceField": "Price",
"searchFieldType": "Edm.Double"
}
],
"embeddingColumns": [
{
"name": "descriptionEmbedding",
"sourceField": "Description"
}
],
"ingestionParameters": {
"contentExtractionMode": "minimal",
"identity": {
"@odata.type": "#Microsoft.Azure.Search.DataUserAssignedIdentity",
"userAssignedIdentity": "/my/userassigned/id"
},
"embeddingModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "model",
"apiKey": "api-key",
"modelName": "text-embedding-3-large"
}
},
"ingestionSchedule": {
"interval": "P1D",
"startTime": "2024-06-06T00:01:50.265Z"
}
}
}
}
SearchServiceCreateKnowledgeSourceMcpServer
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "ks-preview-test",
"description": "Description of the MCP server knowledge source.",
"kind": "mcpServer",
"@odata.etag": "0x1234568AE7E58A1",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"mcpServerParameters": {
"serverURL": "https://mcp.contoso.com/sse",
"authentication": {
"kind": "foundryConnection",
"foundryConnectionParameters": {
"connectionId": "conn-123"
}
},
"tools": [
{
"name": "search-code",
"outputParsing": {
"kind": "json",
"jsonParameters": {
"documentsPath": "$.documents[*]",
"includeContext": true
}
},
"resultsProcessing": "rerank",
"maxOutputTokens": 4096
}
]
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-preview-test",
"kind": "mcpServer",
"description": "Description of the MCP server knowledge source.",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"isServiceLevelKey": false,
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"mcpServerParameters": {
"serverURL": "https://mcp.contoso.com/sse",
"authentication": {
"kind": "foundryConnection",
"foundryConnectionParameters": {
"connectionId": "conn-123"
}
},
"tools": [
{
"name": "search-code",
"resultsProcessing": "rerank",
"maxOutputTokens": 4096,
"outputParsing": {
"kind": "json",
"jsonParameters": {
"documentsPath": "$.documents[*]",
"includeContext": true
}
}
}
]
}
}
SearchServiceCreateKnowledgeSourceOpenAICompatible
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "compatible-preview-file-source",
"description": "Description of the File knowledge source.",
"kind": "file",
"fileParameters": {
"ingestionParameters": {
"embeddingModel": {
"kind": "openAICompatible",
"openAICompatibleParameters": {
"uri": "https://model-gateway.contoso.com/teams/catalog/embeddings?route=primary&api-version=2026-01-01",
"modelName": "text-embedding-3-small",
"dimensions": 1024,
"headers": {
"api-key": "EXAMPLE-NOT-A-REAL-SECRET",
"x-route-key": "EXAMPLE-NOT-A-REAL-ROUTING-SECRET"
}
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"contentExtractionMode": "standard",
"aiServices": {
"uri": "https://my-ai-service.azure.com/",
"apiKey": "api-key"
}
}
},
"corsOptions": {
"allowedOrigins": [
"https://myapp.example.com"
],
"maxAgeInSeconds": 300
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "compatible-preview-file-source",
"kind": "file",
"description": "Description of the File knowledge source.",
"fileParameters": {
"ingestionParameters": {
"contentExtractionMode": "standard",
"embeddingModel": {
"kind": "openAICompatible",
"openAICompatibleParameters": {
"uri": "https://model-gateway.contoso.com/teams/catalog/embeddings?route=primary&api-version=2026-01-01",
"modelName": "text-embedding-3-small",
"dimensions": 1024
}
},
"chatCompletionModel": {
"kind": "azureOpenAI",
"azureOpenAIParameters": {
"resourceUri": "https://test-sample.openai.azure.com/",
"deploymentId": "myDeployment",
"apiKey": "api-key",
"modelName": "gpt-4o-mini"
}
},
"aiServices": {
"uri": "https://my-ai-service.azure.com/",
"apiKey": "api-key"
}
},
"createdResources": {
"index": "compatible-preview-file-source-index"
}
},
"corsOptions": {
"allowedOrigins": [
"https://myapp.example.com"
],
"maxAgeInSeconds": 300
}
}
SearchServiceCreateKnowledgeSourceWeb
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"webParameters": {
"domains": {
"allowedDomains": [
{
"address": "example.com",
"includeSubpages": true
},
{
"address": "another-example.com"
}
],
"blockedDomains": [
{
"address": "blocked.com"
},
{
"address": "spam.com",
"includeSubpages": true
}
]
}
},
"name": "ks-preview-test",
"description": "Description of the knowledge source.",
"kind": "web",
"@odata.etag": "0x1234568AE7E58A1",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-preview-test",
"kind": "web",
"description": "Description of the knowledge source.",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"isServiceLevelKey": false,
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"webParameters": {
"domains": {
"allowedDomains": [
{
"address": "example.com",
"includeSubpages": true
},
{
"address": "another-example.com"
}
],
"blockedDomains": [
{
"address": "blocked.com"
},
{
"address": "spam.com",
"includeSubpages": true
}
]
}
}
}
SearchServiceCreateKnowledgeSourceWithFilterAutoConfiguration
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "ks-preview-test",
"description": "Description of the knowledge source.",
"kind": "searchIndex",
"resultsProcessing": "none",
"@odata.etag": "0x1234568AE7E58A1",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"searchIndexParameters": {
"searchIndexName": "preview-test",
"sourceDataFields": [
{
"name": "description"
},
{
"name": "category"
}
],
"searchFields": [
{
"name": "*"
}
],
"semanticConfigurationName": "testconfig",
"baseFilter": "category eq 'news'",
"queryHints": {
"filters": [
{
"field": "model",
"autoConfiguration": {
"cacheTtl": 3600,
"maxFacetValueCount": 64
},
"filterInstructions": "Product model name."
}
]
}
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-preview-test",
"kind": "searchIndex",
"description": "Description of the knowledge source.",
"resultsProcessing": "none",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"isServiceLevelKey": false,
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"searchIndexParameters": {
"searchIndexName": "preview-test",
"semanticConfigurationName": "testconfig",
"baseFilter": "category eq 'news'",
"sourceDataFields": [
{
"name": "description"
},
{
"name": "category"
}
],
"searchFields": [
{
"name": "*"
}
],
"queryHints": {
"filters": [
{
"field": "model",
"filterInstructions": "Product model name.",
"autoConfiguration": {
"cacheTtl": 3600,
"maxFacetValueCount": 64
}
}
]
}
}
}
SearchServiceCreateKnowledgeSourceWithTopicGraphs
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "ks-preview-test",
"description": "Description of the knowledge source.",
"kind": "searchIndex",
"resultsProcessing": "none",
"@odata.etag": "0x1234568AE7E58A1",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"searchIndexParameters": {
"searchIndexName": "preview-test",
"sourceDataFields": [
{
"name": "description"
},
{
"name": "category"
}
],
"searchFields": [
{
"name": "*"
}
],
"semanticConfigurationName": "testconfig",
"baseFilter": "category eq 'news'",
"queryHints": {
"filters": [
{
"field": "model",
"fieldValues": [
"Model-X100",
"Model-X200",
"Model-Pro"
],
"filterInstructions": "Product model name."
}
],
"boosts": [
{
"kind": "fieldValue",
"boostInstructions": "Document language; pick from the user's locale.",
"field": "language",
"fieldValues": [
"en",
"ja",
"fr",
"de"
],
"boost": 2
}
]
},
"topicGraph": {
"kind": "diverse",
"minDiversityPoolSize": 1000,
"diversityFactor": 0.1
}
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-preview-test",
"kind": "searchIndex",
"description": "Description of the knowledge source.",
"resultsProcessing": "none",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"isServiceLevelKey": false,
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"searchIndexParameters": {
"searchIndexName": "preview-test",
"semanticConfigurationName": "testconfig",
"baseFilter": "category eq 'news'",
"sourceDataFields": [
{
"name": "description"
},
{
"name": "category"
}
],
"searchFields": [
{
"name": "*"
}
],
"queryHints": {
"filters": [
{
"field": "model",
"fieldValues": [
"Model-X100",
"Model-X200",
"Model-Pro"
],
"filterInstructions": "Product model name."
}
],
"boosts": [
{
"kind": "fieldValue",
"field": "language",
"fieldValues": [
"en",
"ja",
"fr",
"de"
],
"boost": 2,
"boostInstructions": "Document language; pick from the user's locale."
}
]
},
"topicGraph": {
"kind": "diverse",
"diversityFactor": 0.1,
"minDiversityPoolSize": 1000
}
}
}
SearchServiceCreateKnowledgeSourceWorkIQ
Sample request
POST https://typespecpreviewexampleservice.search.windows.net/knowledgesources?api-version=2026-11-01-preview
{
"name": "ks-preview-test",
"description": "Description of the WorkIQ knowledge source.",
"kind": "workIQ",
"@odata.etag": "0x1234568AE7E58A1",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"workIQParameters": {
"entraAppAuthentication": {
"applicationId": "11111111-1111-1111-1111-111111111111",
"federatedCredentialId": "22222222-2222-2222-2222-222222222222"
}
}
}
Sample response
{
"@odata.etag": "0x1234568AE7E58A1",
"name": "ks-preview-test",
"kind": "workIQ",
"description": "Description of the WorkIQ knowledge source.",
"encryptionKey": {
"keyVaultKeyName": "myUserManagedEncryptionKey-createdinAzureKeyVault",
"keyVaultKeyVersion": "myKeyVersion-32charAlphaNumericString",
"keyVaultUri": "https://myKeyVault.vault.azure.net",
"isServiceLevelKey": false,
"accessCredentials": {
"applicationId": "00000000-0000-0000-0000-000000000000",
"applicationSecret": "<applicationSecret>"
}
},
"workIQParameters": {
"entraAppAuthentication": {
"applicationId": "11111111-1111-1111-1111-111111111111",
"federatedCredentialId": "22222222-2222-2222-2222-222222222222"
}
}
}
Definitions
| Name | Description |
|---|---|
| Accept |
The Accept header. |
| AIServices |
Parameters for AI Services. |
|
Asset |
Configuration for an asset store used to store extracted assets such as images. |
|
Azure |
Configuration for Azure Blob Storage knowledge source. |
|
Azure |
Parameters for Azure Blob Storage knowledge source. |
|
Azure |
The Azure Open AI model name that will be called. |
|
Azure |
Specifies the parameters for connecting to the Azure OpenAI resource. |
|
Balanced |
Blends pure vector similarity with diversity-aware retrieval. Recommended default to balance diversity with relevance. |
|
Content |
Maps a SQL column to a search index field. |
|
Cors |
Defines options to control Cross-Origin Resource Sharing (CORS) for an index. |
|
Diverse |
Uses topic graph diverse retrieval. |
|
Embedding |
Maps a SQL column to a vector field for embedding. |
|
Entra |
Configuration for a customer-owned Microsoft Entra app registration used for federated credential-based on-behalf-of authentication. |
|
Error |
The resource management error additional info. |
|
Error |
The error detail. |
|
Error |
Common error response for all Azure Resource Manager APIs to return error details for failed operations. (This also follows the OData error response format.). |
|
Fabric |
Configuration for Fabric Data Agent knowledge source. |
|
Fabric |
Parameters for Fabric Data Agent knowledge source. |
|
Fabric |
Configuration for Fabric Ontology knowledge source. |
|
Fabric |
Parameters for Fabric Ontology knowledge source. |
|
File |
Configuration for File knowledge source that supports direct file upload and indexing. |
|
File |
Parameters for File knowledge source. |
|
Freshness |
Configuration for freshness-aware retrieval. When set, newer documents receive a ranking boost during retrieval. |
|
Indexed |
Configuration for OneLake knowledge source. |
|
Indexed |
Parameters for OneLake knowledge source. |
|
Indexed |
Specifies which SharePoint libraries to access. |
|
Indexed |
Configuration for SharePoint knowledge source. |
|
Indexed |
Parameters for SharePoint knowledge source. |
|
Indexed |
Configuration for indexed SQL knowledge source. |
|
Indexed |
Parameters for indexed SQL knowledge source. |
|
Indexing |
Represents a schedule for indexer execution. |
|
Knowledge |
Specifies the Azure OpenAI resource used to do query planning. |
|
Knowledge |
Specifies Microsoft Retriever 1 used for query planning and retrieval. |
|
Knowledge |
The AI model to be used for query planning. |
|
Knowledge |
Specifies a customer-controlled OpenAI-compatible model for knowledge base retrieval or Minimal-mode knowledge source image verbalization. For retrieval, the model profile selects Chat Completions or Responses. Not supported for Standard/CU extraction or knowledge bases with Web knowledge sources. |
|
Knowledge |
Connection parameters for an OpenAI-compatible Chat Completions or Responses endpoint. Creation requires exactly one of nonempty headers or managedIdentityAudience. Updates can omit headers to preserve credentials for an unchanged connection and model profile. |
|
Knowledge |
Specifies the Azure OpenAI resource used to vectorize a query string. |
|
Knowledge |
Configures storage for cached knowledge source enrichment results. Requires a GPv2 storage account with Blob and Table endpoints. The cache storage binding and identity cannot be changed after creation, and the cache cannot be removed while using the graph extraction workflow. |
|
Knowledge |
Configures graph extraction from an Azure Blob knowledge source with native Blob soft delete enabled before indexing. ADLS Gen2, ACL ingestion, and sensitivity-label ingestion are not supported. Distinct ontology changes must wait until no synchronization is active. |
|
Knowledge |
A grounding source for graph extraction. Only same-service search indexes are supported. |
|
Knowledge |
Identifies a search index used to ground extracted entities. |
|
Knowledge |
The explicit source kind for a grounding reference. Only searchIndex is supported. |
|
Knowledge |
An inline ontology for graph extraction. The only supported source is a constrained JSON-LD document supplied directly in the request. |
|
Knowledge |
The explicit source kind for an ontology reference. Only "inline" is supported. |
|
Knowledge |
Consolidates all general ingestion settings for knowledge sources. |
|
Knowledge |
Permission types to ingest together with document content. |
|
Knowledge |
The kind of the knowledge source. |
|
Knowledge |
Specifies the network access mode for knowledge source ingestion. Default is 'public'. |
|
Knowledge |
An OpenAI-compatible embeddings endpoint used for managed knowledge source ingestion and generated query vectorization. Changing from a native embedding model requires recreating the knowledge source and indexing it again. The URI, modelName, and dimensions cannot be changed after creation. |
|
Knowledge |
Controls whether a knowledge source's results are reranked. |
|
Mcp |
The kind of authentication for an MCP server. |
|
Mcp |
Automatically detect the output format and parse accordingly. |
|
Mcp |
Authentication using an Azure AI Foundry connection. |
|
Mcp |
Parameters for Foundry connection authentication. |
|
Mcp |
Parse the output as a JSON document using the configured JSON parameters. |
|
Mcp |
Configuration for a knowledge source backed by an MCP (Model Context Protocol) server. |
|
Mcp |
Parameters for an MCP server knowledge source. |
|
Mcp |
Treat the output as a single block without any parsing. |
|
Mcp |
Parameters for JSON output parsing. |
|
Mcp |
The kind of output parsing for an MCP server tool. |
|
Mcp |
Parameters for split output parsing. |
|
Mcp |
Split the output into pages using the configured split parameters. |
|
Mcp |
Authentication using stored HTTP headers. |
|
Mcp |
Parameters for stored headers authentication. |
|
Mcp |
Represents a single tool within an MCP server knowledge source. |
|
None |
Uses normal vector search without topic graph diverse retrieval. |
|
Open |
Connection parameters for a direct OpenAI-compatible embeddings endpoint. Creation requires exactly one of nonempty headers or managedIdentityAudience. Updates can omit headers to preserve credentials for an unchanged connection and embedding profile. |
|
Remote |
Configuration for remote SharePoint knowledge source. |
|
Remote |
Parameters for remote SharePoint knowledge source. |
|
Search |
Clears the identity property of a datasource. |
|
Search |
Specifies the identity for a datasource to use. |
|
Search |
Field reference for a search index. |
|
Search |
Knowledge Source targeting a search index. |
|
Search |
The kind of boost hint for a search index knowledge source. |
|
Search |
A hint that boosts documents based on a field value. |
|
Search |
A hint that identifies a field and exhaustive grounding values the query planner can use when constructing a filter. |
|
Search |
Configures automatic resolution of a filter hint's grounding values from the target index facets. |
|
Search |
A hint that boosts documents based on a multi-word expression. |
|
Search |
Parameters for search index knowledge source. |
|
Search |
Hints that guide query planning toward useful filters and boosts for a search index knowledge source. |
|
Search |
A customer-managed encryption key in Azure Key Vault. Keys that you create and manage can be used to encrypt or decrypt data-at-rest, such as indexes and synonym maps. |
|
Split |
The language codes supported for input text by SplitSkill. |
|
Text |
A value indicating which split mode to perform. |
|
Vector |
The kind of topic graph vector search to use. |
|
Vector |
The vectorization method to be used during query time. |
|
Web |
Knowledge Source targeting web results. |
|
Web |
Configuration for web knowledge source domain. |
|
Web |
Domain allow/block configuration for web knowledge source. |
|
Web |
Parameters for web knowledge source. |
|
Work |
Configuration for WorkIQ knowledge source. |
|
Work |
Parameters for a WorkIQ knowledge source. |
Accept
The Accept header.
| Value | Description |
|---|---|
| application/json;odata.metadata=minimal |
AIServices
Parameters for AI Services.
| Name | Type | Description |
|---|---|---|
| apiKey |
string |
The API key for accessing AI Services. |
| uri |
string (uri) |
The URI of the AI Services endpoint. |
AssetStore
Configuration for an asset store used to store extracted assets such as images.
| Name | Type | Description |
|---|---|---|
| connectionString |
string |
The connection string for the asset store. |
| containerName |
string |
The name of the blob container within the asset store where extracted assets (for example, images) are stored. |
AzureBlobKnowledgeSource
Configuration for Azure Blob Storage knowledge source.
| Name | Type | Description |
|---|---|---|
| @odata.etag |
string |
The ETag of the knowledge source. |
| azureBlobParameters |
The type of the knowledge source. |
|
| description |
string |
Optional user-defined description. |
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
|
| kind |
string:
azure |
The type of the knowledge source. |
| name |
string |
The name of the knowledge source. |
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
AzureBlobKnowledgeSourceParameters
Parameters for Azure Blob Storage knowledge source.
| Name | Type | Default value | Description |
|---|---|---|---|
| connectionString |
string |
Key-based connection string or the ResourceId format if using a managed identity. |
|
| containerName |
string |
The name of the blob storage container. |
|
| createdResources |
object |
Resources created by the knowledge source. |
|
| folderPath |
string |
Optional folder path within the container. |
|
| graphExtraction |
Graph extraction configuration for Azure Blob knowledge sources. Configure native Blob soft delete on the source before the first indexing run. ADLS Gen2, ACL ingestion, and sensitivity-label ingestion are not supported for this workflow. |
||
| ingestionParameters |
Consolidates all general ingestion settings. |
||
| isADLSGen2 |
boolean |
False |
Set to true if connecting to an ADLS Gen2 storage account. Default is false. |
| topicGraph | VectorQueryTopicGraph: |
Default topic graph vector search options for this Azure Blob knowledge source. |
AzureOpenAIModelName
The Azure Open AI model name that will be called.
| Value | Description |
|---|---|
| text-embedding-ada-002 |
TextEmbeddingAda002 model. |
| text-embedding-3-large |
TextEmbedding3Large model. |
| text-embedding-3-small |
TextEmbedding3Small model. |
| gpt-4o |
Gpt4o model. |
| gpt-4o-mini |
Gpt4oMini model. |
| gpt-4.1 |
Gpt41 model. |
| gpt-4.1-mini |
Gpt41Mini model. |
| gpt-4.1-nano |
Gpt41Nano model. |
| gpt-5 |
Gpt5 model. |
| gpt-5-mini |
Gpt5Mini model. |
| gpt-5-nano |
Gpt5Nano model. |
| gpt-5.1 |
Gpt51 model. |
| gpt-5.2 |
Gpt52 model. |
| gpt-5.4 |
Gpt54 model. |
| gpt-5.4-mini |
Gpt54Mini model. |
| gpt-5.4-nano |
Gpt54Nano model. |
| gpt-5.5 |
Gpt55 model. |
| gpt-5.6-sol |
Gpt56Sol model. |
| gpt-5.6-terra |
Gpt56Terra model. |
| gpt-5.6-luna |
Gpt56Luna model. |
| gpt-6-astra |
Gpt6Astra model. |
| gpt-6-sol |
Gpt6Sol model. |
| gpt-6-luna |
Gpt6Luna model. |
| gpt-6.1-sol |
Gpt61Sol model. |
AzureOpenAIVectorizerParameters
Specifies the parameters for connecting to the Azure OpenAI resource.
| Name | Type | Description |
|---|---|---|
| apiKey |
string |
API key of the designated Azure OpenAI resource. |
| authIdentity | SearchIndexerDataIdentity: |
The user-assigned managed identity used for outbound connections. |
| deploymentId |
string |
ID of the Azure OpenAI model deployment on the designated resource. |
| modelName |
The name of the embedding model that is deployed at the provided deploymentId path. |
|
| resourceUri |
string (uri) |
The resource URI of the Azure OpenAI resource. |
BalancedVectorQueryTopicGraph
Blends pure vector similarity with diversity-aware retrieval. Recommended default to balance diversity with relevance.
| Name | Type | Description |
|---|---|---|
| kind |
string:
balanced |
The kind of topic graph vector search to use. |
| minDiversityPoolSize |
integer (int32) minimum: 250maximum: 10000 |
The minimum number of vector candidates to retrieve before topic graph sampling. The default is 1,000. |
ContentColumnMapping
Maps a SQL column to a search index field.
| Name | Type | Description |
|---|---|---|
| name |
string |
Target index field name. |
| searchFieldType |
string |
Azure AI Search field type (e.g., Edm.String, Edm.Int32). |
| sourceField |
string |
SQL column name. |
CorsOptions
Defines options to control Cross-Origin Resource Sharing (CORS) for an index.
| Name | Type | Description |
|---|---|---|
| allowedOrigins |
string[] |
The list of origins from which JavaScript code will be granted access to your index. Can contain a list of hosts of the form {protocol}://{fully-qualified-domain-name}[:{port#}], or a single '*' to allow all origins (not recommended). |
| maxAgeInSeconds |
integer (int64) |
The duration for which browsers should cache CORS preflight responses. Defaults to 5 minutes. |
DiverseVectorQueryTopicGraph
Uses topic graph diverse retrieval.
| Name | Type | Description |
|---|---|---|
| diversityFactor |
number (float) minimum: 0maximum: 1 |
The diversity factor used for topic graph diverse retrieval. If omitted, the default configured on the topic graph profile is used. |
| kind |
string:
diverse |
The kind of topic graph vector search to use. |
| minDiversityPoolSize |
integer (int32) minimum: 250maximum: 10000 |
The minimum number of vector candidates to retrieve before topic graph sampling. The default is 1,000. |
EmbeddingColumnMapping
Maps a SQL column to a vector field for embedding.
| Name | Type | Description |
|---|---|---|
| name |
string |
Target vector field name in the search index. |
| sourceField |
string |
SQL column used as input for embedding generation. |
EntraAppAuthentication
Configuration for a customer-owned Microsoft Entra app registration used for federated credential-based on-behalf-of authentication.
| Name | Type | Description |
|---|---|---|
| applicationId |
string (uuid) |
The application (client) ID of the customer-owned Entra app registration. |
| federatedCredentialId |
string (uuid) |
The federated credential ID configured on the app registration, enabling the search service to authenticate as the app without a stored client secret. |
| tenantId |
string (uuid) |
The tenant ID of the app registration. Required when the app registration is in a different tenant than the search service. If omitted, the search service's tenant is used. |
ErrorAdditionalInfo
The resource management error additional info.
| Name | Type | Description |
|---|---|---|
| info |
searchservice.knowledgesources.create |
The additional info. |
| type |
string |
The additional info type. |
ErrorDetail
The error detail.
| Name | Type | Description |
|---|---|---|
| additionalInfo |
The error additional info. |
|
| code |
string |
The error code. |
| details |
The error details. |
|
| message |
string |
The error message. |
| target |
string |
The error target. |
ErrorResponse
Common error response for all Azure Resource Manager APIs to return error details for failed operations. (This also follows the OData error response format.).
| Name | Type | Description |
|---|---|---|
| error |
The error object. |
FabricDataAgentKnowledgeSource
Configuration for Fabric Data Agent knowledge source.
| Name | Type | Description |
|---|---|---|
| @odata.etag |
string |
The ETag of the knowledge source. |
| description |
string |
Optional user-defined description. |
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
|
| fabricDataAgentParameters |
The parameters for the Fabric Data Agent knowledge source. |
|
| kind |
string:
fabric |
The type of the knowledge source. |
| name |
string |
The name of the knowledge source. |
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
FabricDataAgentKnowledgeSourceParameters
Parameters for Fabric Data Agent knowledge source.
| Name | Type | Description |
|---|---|---|
| dataAgentId |
string |
Specifies which Fabric Data Agent to access. |
| workspaceId |
string |
Fabric workspace ID. |
FabricOntologyKnowledgeSource
Configuration for Fabric Ontology knowledge source.
| Name | Type | Description |
|---|---|---|
| @odata.etag |
string |
The ETag of the knowledge source. |
| description |
string |
Optional user-defined description. |
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
|
| fabricOntologyParameters |
The parameters for the Fabric Ontology knowledge source. |
|
| kind |
string:
fabric |
The type of the knowledge source. |
| name |
string |
The name of the knowledge source. |
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
FabricOntologyKnowledgeSourceParameters
Parameters for Fabric Ontology knowledge source.
| Name | Type | Description |
|---|---|---|
| ontologyId |
string |
The ID of the ontology to use from the Fabric workspace. |
| workspaceId |
string |
The Fabric workspace ID containing the ontology. |
FileKnowledgeSource
Configuration for File knowledge source that supports direct file upload and indexing.
| Name | Type | Description |
|---|---|---|
| @odata.etag |
string |
The ETag of the knowledge source. |
| corsOptions |
Options to control Cross-Origin Resource Sharing (CORS) for the File knowledge source's file endpoints (upload, list, update, delete). |
|
| description |
string |
Optional user-defined description. |
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
|
| fileParameters |
The parameters for the File knowledge source. |
|
| kind |
string:
file |
The type of the knowledge source. |
| name |
string |
The name of the knowledge source. |
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
FileKnowledgeSourceParameters
Parameters for File knowledge source.
| Name | Type | Description |
|---|---|---|
| createdResources |
object |
Resources created by the file knowledge source. |
| ingestionParameters |
Consolidates all general ingestion settings for the File knowledge source, including the content extraction mode and an optional embeddingModel. |
FreshnessPolicy
Configuration for freshness-aware retrieval. When set, newer documents receive a ranking boost during retrieval.
| Name | Type | Description |
|---|---|---|
| boostingDuration |
string |
ISO 8601 duration for the freshness boosting window (e.g. 'P90D' for 90 days). Documents newer than this duration receive a ranking boost during retrieval. |
IndexedOneLakeKnowledgeSource
Configuration for OneLake knowledge source.
| Name | Type | Description |
|---|---|---|
| @odata.etag |
string |
The ETag of the knowledge source. |
| description |
string |
Optional user-defined description. |
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
|
| indexedOneLakeParameters |
The parameters for the knowledge source. |
|
| kind |
string:
indexed |
The type of the knowledge source. |
| name |
string |
The name of the knowledge source. |
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
IndexedOneLakeKnowledgeSourceParameters
Parameters for OneLake knowledge source.
| Name | Type | Description |
|---|---|---|
| createdResources |
object |
Resources created by the knowledge source. |
| fabricWorkspaceId |
string |
OneLake workspace ID. |
| ingestionParameters |
Consolidates all general ingestion settings. |
|
| lakehouseId |
string |
Specifies which OneLake lakehouse to access. |
| targetPath |
string |
Optional OneLakehouse folder or shortcut to filter OneLake content. |
IndexedSharePointContainerName
Specifies which SharePoint libraries to access.
| Value | Description |
|---|---|
| defaultSiteLibrary |
Index content from the site's default document library. |
| allSiteLibraries |
Index content from every document library in the site. |
| useQuery |
Use a query to filter SharePoint content. |
| allSiteLists |
Index content from every list in the site. |
| allSitePages |
Index content from every page in the site. |
| allSiteContent |
Index content from all supported libraries, lists, and pages in the site. |
IndexedSharePointKnowledgeSource
Configuration for SharePoint knowledge source.
| Name | Type | Description |
|---|---|---|
| @odata.etag |
string |
The ETag of the knowledge source. |
| description |
string |
Optional user-defined description. |
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
|
| indexedSharePointParameters |
The parameters for the knowledge source. |
|
| kind |
string:
indexed |
The type of the knowledge source. |
| name |
string |
The name of the knowledge source. |
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
IndexedSharePointKnowledgeSourceParameters
Parameters for SharePoint knowledge source.
| Name | Type | Description |
|---|---|---|
| connectionString |
string |
SharePoint connection string with format: SharePointOnlineEndpoint=[SharePoint site url];ApplicationId=[Azure AD App ID];ApplicationSecret=[Azure AD App client secret];TenantId=[SharePoint site tenant id] |
| containerName |
Specifies which SharePoint libraries to access. |
|
| createdResources |
object |
Resources created by the knowledge source. |
| ingestionParameters |
Consolidates all general ingestion settings. |
|
| query |
string |
Optional query to filter SharePoint content. |
IndexedSqlKnowledgeSource
Configuration for indexed SQL knowledge source.
| Name | Type | Description |
|---|---|---|
| @odata.etag |
string |
The ETag of the knowledge source. |
| description |
string |
Optional user-defined description. |
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
|
| indexedSqlParameters |
The parameters for the SQL knowledge source. |
|
| kind |
string:
indexed |
The type of the knowledge source. |
| name |
string |
The name of the knowledge source. |
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
IndexedSqlKnowledgeSourceParameters
Parameters for indexed SQL knowledge source.
| Name | Type | Description |
|---|---|---|
| connectionString |
string |
The connection string for the Azure SQL Database or SQL Managed Instance. |
| contentColumns |
Optional column mappings for content fields. If omitted, all columns are auto-discovered. |
|
| createdResources |
object |
Resources created by the knowledge source. |
| embeddingColumns |
Optional column mappings for embedding vector fields. If omitted, no vector fields are created. |
|
| highWaterMarkColumnName |
string |
Optional column name for high water mark change detection. If provided, uses HighWaterMarkChangeDetectionPolicy. |
| ingestionParameters |
Consolidates all general ingestion settings including embedding model, schedule, and identity. |
|
| tableOrView |
string |
The name of the table or view to index. Can be schema-qualified (e.g., 'dbo.MyTable'). |
IndexingSchedule
Represents a schedule for indexer execution.
| Name | Type | Description |
|---|---|---|
| interval |
string (duration) |
The interval of time between indexer executions. |
| startTime |
string (date-time) |
The time when an indexer should start running. |
KnowledgeBaseAzureOpenAIModel
Specifies the Azure OpenAI resource used to do query planning.
| Name | Type | Description |
|---|---|---|
| azureOpenAIParameters |
Azure OpenAI parameters. |
|
| kind |
string:
azure |
The AI model to be used for query planning. |
KnowledgeBaseMicrosoftRetriever1Model
Specifies Microsoft Retriever 1 used for query planning and retrieval.
| Name | Type | Description |
|---|---|---|
| kind |
string:
microsoft |
The AI model to be used for query planning. |
KnowledgeBaseModelKind
The AI model to be used for query planning.
| Value | Description |
|---|---|
| azureOpenAI |
Use Azure Open AI models for query planning. |
| openAICompatible |
Use a customer-controlled OpenAI-compatible endpoint for knowledge base retrieval or knowledge source image verbalization. |
| microsoftRetriever1 |
Use Microsoft Retriever 1 for query planning and retrieval. |
KnowledgeBaseOpenAICompatibleModel
Specifies a customer-controlled OpenAI-compatible model for knowledge base retrieval or Minimal-mode knowledge source image verbalization. For retrieval, the model profile selects Chat Completions or Responses. Not supported for Standard/CU extraction or knowledge bases with Web knowledge sources.
| Name | Type | Description |
|---|---|---|
| kind |
string:
open |
The AI model to be used for query planning. |
| openAICompatibleParameters |
Connection and authentication parameters for the OpenAI-compatible endpoint. |
KnowledgeBaseOpenAICompatibleParameters
Connection parameters for an OpenAI-compatible Chat Completions or Responses endpoint. Creation requires exactly one of nonempty headers or managedIdentityAudience. Updates can omit headers to preserve credentials for an unchanged connection and model profile.
| Name | Type | Description |
|---|---|---|
| authIdentity | SearchIndexerDataIdentity: |
The user-assigned managed identity used to acquire a token for managedIdentityAudience. Omit to use the search service's system-assigned identity. Allowed only with managedIdentityAudience. |
| headers |
object (password) |
Nonempty stored HTTP headers for endpoint authentication. Both names and values are secret and are never returned in responses. Empty maps are invalid. Mutually exclusive with managedIdentityAudience and authIdentity. On update, omitted headers are preserved only on the same resource and model binding when the exact endpoint, model profile, and authentication identity are unchanged; otherwise, supply fresh credentials. |
| managedIdentityAudience |
string |
The bare canonical application GUID of the customer's third-party Microsoft Entra application for managed identity authentication. Do not include an api:// prefix or /.default suffix. Mutually exclusive with headers. |
| modelName |
A supported chat model name that determines Search's capabilities and limits. For knowledge source image verbalization, this is sent as the model selector in the request body; the URI path selects Chat Completions or Responses independently of this name. For knowledge base retrieval, GPT-6 model profiles use Responses and existing model profiles use Chat Completions; the endpoint must support the selected protocol, including stateless tool continuation for Responses. The retrieval request body omits model; the URI or gateway selects the actual model and supplies any required provider model identifier. Embedding models and arbitrary provider protocols are not supported. |
|
| uri |
string (uri) |
The complete HTTPS POST URL, including path and query parameters. Sent unchanged without appending a path or API version; redirects are not followed. For knowledge base retrieval, the endpoint must accept the model profile's Chat Completions or Responses protocol. For knowledge source image verbalization, the URI path must end in /chat/completions or /responses; query parameters do not select the protocol. |
KnowledgeSourceAzureOpenAIVectorizer
Specifies the Azure OpenAI resource used to vectorize a query string.
| Name | Type | Description |
|---|---|---|
| azureOpenAIParameters |
Contains the parameters specific to Azure OpenAI embedding vectorization. |
|
| kind |
string:
azure |
The name of the kind of vectorization method being configured for use with vector search. |
KnowledgeSourceCache
Configures storage for cached knowledge source enrichment results. Requires a GPv2 storage account with Blob and Table endpoints. The cache storage binding and identity cannot be changed after creation, and the cache cannot be removed while using the graph extraction workflow.
| Name | Type | Default value | Description |
|---|---|---|---|
| enableReprocessing |
boolean |
True |
Whether cached enrichment results can be reprocessed when the enrichment configuration changes. Must be true for graph extraction cache replay. |
| identity | SearchIndexerDataIdentity: |
The managed identity used to connect to the enrichment cache. If omitted for a ResourceId connection string, the system-assigned managed identity is used. The identity cannot be changed after the cache is configured. |
|
| storageConnectionString |
string (password) |
The connection string to the storage account where cached enrichment results are persisted. |
KnowledgeSourceGraphExtractionParameters
Configures graph extraction from an Azure Blob knowledge source with native Blob soft delete enabled before indexing. ADLS Gen2, ACL ingestion, and sensitivity-label ingestion are not supported. Distinct ontology changes must wait until no synchronization is active.
| Name | Type | Default value | Description |
|---|---|---|---|
| graphName |
string |
The name of the graph to create. |
|
| grounding |
Optional grounding source used to resolve extracted entities. |
||
| ontology |
The ontology used to extract triples. If absent or null at creation, a configured enrichment cache allows ingestion to produce searchable chunks and cached enrichment without extracting triples. Once an ontology is attached, it cannot be removed. Distinct ontology changes must wait until no synchronization is active. |
||
| pageDegreeOfParallelism |
integer (int32) minimum: 1maximum: 1024 |
128 |
Maximum number of pages processed in parallel for graph extraction. |
KnowledgeSourceGraphGrounding
A grounding source for graph extraction. Only same-service search indexes are supported.
| Name | Type | Default value | Description |
|---|---|---|---|
| index |
The same-service search index used for grounding. Required for searchIndex sources. |
||
| kind | searchIndex |
The source kind. If omitted, searchIndex is assumed. Other kinds are rejected. |
KnowledgeSourceGraphGroundingIndex
Identifies a search index used to ground extracted entities.
| Name | Type | Description |
|---|---|---|
| indexName |
string |
The name of the grounding search index. |
| vectorFieldName |
string |
The name of the vector field used for grounding, when vector lookup is configured. |
KnowledgeSourceGraphGroundingSourceKind
The explicit source kind for a grounding reference. Only searchIndex is supported.
| Value | Description |
|---|---|
| searchIndex |
A search index in the same search service. |
KnowledgeSourceGraphOntology
An inline ontology for graph extraction. The only supported source is a constrained JSON-LD document supplied directly in the request.
| Name | Type | Description |
|---|---|---|
| kind |
The source kind. Only "inline" is supported. |
|
| name |
string |
An optional customer-supplied name for the ontology, echoed back on |
| value |
string |
A constrained JSON-LD 1.1 ontology document (flat classes and object/datatype properties), supplied as a JSON-encoded string. |
KnowledgeSourceGraphOntologySourceKind
The explicit source kind for an ontology reference. Only "inline" is supported.
| Value | Description |
|---|---|
| inline |
Ontology content provided inline in the request as a constrained JSON-LD document. |
KnowledgeSourceIngestionParameters
Consolidates all general ingestion settings for knowledge sources.
| Name | Type | Default value | Description |
|---|---|---|---|
| aiServices |
Optional AI Services configuration for content processing. |
||
| assetStore |
Optional asset store configuration for storing extracted assets such as images. |
||
| cache |
Enrichment cache configuration for Azure Blob graph extraction. Requires a GPv2 storage account with Blob and Table endpoints and reprocessing enabled. Once configured, the cache cannot be removed or its storage binding or identity changed. |
||
| chatCompletionModel | KnowledgeBaseModel: |
Optional chat completion model for image verbalization or context extraction. |
|
| contentExtractionMode |
enum:
|
minimal |
Optional content extraction mode. Default is 'minimal'. |
| disableImageVerbalization |
boolean |
False |
Indicates whether image verbalization should be disabled. Default is false. |
| embeddingModel | KnowledgeSourceVectorizer: |
Optional vectorizer configuration for vectorizing content. |
|
| freshnessPolicy |
Optional freshness policy for biasing retrieval toward newer documents. |
||
| identity | SearchIndexerDataIdentity: |
An explicit identity to use for this knowledge source. |
|
| ingestionPermissionOptions |
Optional list of permission types to ingest together with document content. If specified, it will set the indexer permission options for the data source. |
||
| ingestionSchedule |
Optional schedule for data ingestion. |
||
| networkAccessMode | public |
Optional network access mode for ingestion. Set to 'private' to run ingestion in a private execution environment that can reach data sources and dependencies over a private network. Default is 'public'. This is a create-time setting and cannot be changed after the knowledge source is created. |
KnowledgeSourceIngestionPermissionOption
Permission types to ingest together with document content.
| Value | Description |
|---|---|
| userIds |
Ingest explicit user identifiers alongside document content. |
| groupIds |
Ingest group identifiers alongside document content. |
| rbacScope |
Ingest RBAC scope information alongside document content. |
| oneLakeParentFolders |
Ingest OneLake parent folder paths and enable OneLake permission filtering on the generated index. Only supported for indexed OneLake knowledge sources. |
| oneLakeLakehouseId |
Ingest the source item's OneLake lakehouse ID and enable OneLake permission filtering on the generated index. Only supported for indexed OneLake knowledge sources. |
| sensitivityLabels |
Ingest Microsoft Purview sensitivity labels alongside document content. |
KnowledgeSourceKind
The kind of the knowledge source.
| Value | Description |
|---|---|
| searchIndex |
A knowledge source that reads data from a Search Index. |
| azureBlob |
A knowledge source that read and ingest data from Azure Blob Storage to a Search Index. |
| indexedSharePoint |
A knowledge source that reads data from indexed SharePoint. |
| indexedOneLake |
A knowledge source that reads data from indexed OneLake. |
| indexedSql |
A knowledge source that retrieves and ingests data from Azure SQL Database or SQL Managed Instance to a Search Index. |
| web |
A knowledge source that reads data from the web. |
| remoteSharePoint |
A knowledge source that reads data from remote SharePoint. |
| workIQ |
A knowledge source that reads data from work IQ |
| file |
A knowledge source that supports direct file upload and indexing. |
| mcpServer |
A knowledge source backed by an MCP (Model Context Protocol) server. |
| fabricDataAgent |
A knowledge source that retrieves data from a Fabric Data Agent. |
| fabricOntology |
A knowledge source that retrieves data from Microsoft Fabric Ontology ontologies. |
KnowledgeSourceNetworkAccessMode
Specifies the network access mode for knowledge source ingestion. Default is 'public'.
| Value | Description |
|---|---|
| public |
Ingestion runs in the standard, publicly reachable execution environment. This is the default. |
| private |
Ingestion runs in a private execution environment so it can reach data sources and dependencies over a private network (private endpoint / shared private link). |
KnowledgeSourceOpenAICompatibleVectorizer
An OpenAI-compatible embeddings endpoint used for managed knowledge source ingestion and generated query vectorization. Changing from a native embedding model requires recreating the knowledge source and indexing it again. The URI, modelName, and dimensions cannot be changed after creation.
| Name | Type | Description |
|---|---|---|
| kind |
string:
open |
The name of the kind of vectorization method being configured for use with vector search. |
| openAICompatibleParameters |
Connection, authentication, and embedding profile parameters. |
KnowledgeSourceResultsProcessing
Controls whether a knowledge source's results are reranked.
| Value | Description |
|---|---|
| rerank |
Results from this knowledge source go through the reranking pipeline. This is the default behavior. |
| none |
Results from this knowledge source bypass reranking and preserve their underlying order. |
McpServerAuthenticationKind
The kind of authentication for an MCP server.
| Value | Description |
|---|---|
| foundryConnection |
Authenticate using an Azure AI Foundry connection. |
| storedHeaders |
Authenticate using stored HTTP headers. |
McpServerAutoOutputParsing
Automatically detect the output format and parse accordingly.
| Name | Type | Description |
|---|---|---|
| kind |
string:
auto |
The kind of output parsing to apply. |
McpServerFoundryConnectionAuthentication
Authentication using an Azure AI Foundry connection.
| Name | Type | Description |
|---|---|---|
| foundryConnectionParameters |
Parameters for Foundry connection authentication. |
|
| kind |
string:
foundry |
The kind of authentication to use. |
McpServerFoundryConnectionParameters
Parameters for Foundry connection authentication.
| Name | Type | Description |
|---|---|---|
| connectionId |
string |
The Azure AI Foundry connection identifier. |
McpServerJsonOutputParsing
Parse the output as a JSON document using the configured JSON parameters.
| Name | Type | Description |
|---|---|---|
| jsonParameters |
Parameters for JSON output parsing. Required when kind is 'json'. |
|
| kind |
string:
json |
The kind of output parsing to apply. |
McpServerKnowledgeSource
Configuration for a knowledge source backed by an MCP (Model Context Protocol) server.
| Name | Type | Description |
|---|---|---|
| @odata.etag |
string |
The ETag of the knowledge source. |
| description |
string |
Optional user-defined description. |
| encryptionKey |
A description of an encryption key that you create in Azure Key Vault. This key is used to provide an additional level of encryption-at-rest for your knowledge source definition when you want full assurance that no one, not even Microsoft, can decrypt them. Once you have encrypted your knowledge source definition, it will always remain encrypted. The search service will ignore attempts to set this property to null. You can change this property as needed if you want to rotate your encryption key; Your knowledge source definition will be unaffected. Encryption with customer-managed keys is not available for free search services, and is only available for paid services created on or after January 1, 2019. |
|
| kind |
string:
mcp |
The type of the knowledge source. |
| mcpServerParameters |
The parameters for the MCP server knowledge source. |
|
| name |
string |
The name of the knowledge source. |
| resultsProcessing |
Controls whether results from this knowledge source are reranked before they are included in the final result set. Defaults to 'rerank' when not specified. |
McpServerKnowledgeSourceParameters
Parameters for an MCP server knowledge source.
| Name | Type | Description |
|---|---|---|
| authentication | McpServerAuthentication: |
The authentication configuration for the MCP server. |
| serverURL |
string |
The URL of the MCP server endpoint. |
| tools |
The list of tools to invoke on the MCP server. |
McpServerNoneOutputParsing
Treat the output as a single block without any parsing.
| Name | Type | Description |
|---|---|---|
| kind |
string:
none |
The kind of output parsing to apply. |
McpServerOutputParsingJsonParameters
Parameters for JSON output parsing.
| Name | Type | Description |
|---|---|---|
| documentsPath |
string |
The JSON path to the array of documents in the tool output. |
| includeContext |
boolean |
Whether to include surrounding context from the JSON output alongside extracted documents. |
McpServerOutputParsingKind
The kind of output parsing for an MCP server tool.
| Value | Description |
|---|---|
| auto |
Automatically detect the output format and parse accordingly. |
| json |
Parse the output as a JSON document using the configured JSON parameters. |
| split |
Split the output into pages using the configured split parameters. |
| none |
Treat the output as a single block without any parsing. |
McpServerOutputParsingSplitParameters
Parameters for split output parsing.
| Name | Type | Description |
|---|---|---|
| defaultLanguageCode |
A value indicating which language code to use. Default is |
|
| maximumPageLength |
integer (int32) |
The maximum number of characters per page. |
| maximumPagesToTake |
integer (int32) |
The maximum number of pages to take from the output. |
| pageOverlapLength |
[...]
